#ifndef CCHANNELPARAMS_H
#define CCHANNELPARAMS_H

#include <QtGui/QWidget>
#include "ui_cchannelparams.h"
#include "DemoPublic.h"

#define KIT_SHOWSTRING_LEN 44
//using namespace Ui;

class CChannelParams : public QWidget
{
    Q_OBJECT

public:
    CChannelParams(QWidget *parent = 0);
    ~CChannelParams();

    //event
    void showEvent ( QShowEvent * event );

    int setUserID(long lUserID);
    int getChannelNum();   //get the channel and IP channel. (Used by myself.)

    //get all information
    int getAllInfo();
    int setAllInfo();

    int getCompressInfo(int iCompIndex); //Get compress parameters.
    int setCompressInfo(); //Set compress parameters.

    int getRecordInfo(); //Get record parameter.
    int setRecordInfo(); //Set record parameter.

    int getPictureInfo();  //ȡͼ
    int setPictureInfo();  //ͼ

    int getShowStringInfo();//ȡַӲ
    int setShowStringInfo();//ַӲ

public slots:
    //(combox changed)
    void comboChNoChanged ( int iChannelIndex );
    void comboCompChanged(int iCompIndex);
    void comboVideoBitChanged(int iVideoBitIndex);
    void comboStringNoChanged(int iStringNo);

    //(btn)
    void clickBtnRemoteRecord();  //¼ʱƻ.
    void clickBtnVILost();              //ƵźŶʧ
    void clickBtnShelter();               //ڵ
    void on_btnMotion_clicked();   //ƶ
    void on_btnHide_clicked();       //ڵ

    //(click check)Ƿʱ¼
    void clickCheckVideoRecord();
    //(click check)ǷĻʾͨ
    void clickCheckShowChanName();
    //(click check)ǷźŶʧ
    void clickCheckVILost();
    //(click check)Ƿڵ
    void clickCheckShelter();
    //(click check)Ƿƶ
    void clickCheckMotion();
    //(click check)Ƿڵ
    void clickCheckHide();
    //(click check)ǷʾOSD
    void clickCheckOSD();
    //Ƿʾַ
    void clickCheckShowString();

private:
    Ui::CChannelParamsClass ui;
    long m_lUserID;
    long m_lChannel;
    int m_iArryChannel[MAX_CHANNUM_V30];//the index is  combox index, the value is channel ID
    int m_iStartChan;            // start channel NO.
    int m_iSimChannelNum;  //ʵʿģͨ

    NET_DVR_RECORD_V30 m_struRecord;//¼ʱ¼ʱ趨
    BOOL m_bSetRecord; //ʾ¼Сáťûбѡ"ʱ¼"ʱֵΪ

    NET_DVR_VILOST_V30 m_struVILost; //ͼ->źŶʧ
    BOOL m_bVILost;                                   //źŶʧСáťûб

    NET_DVR_SHELTER  m_struShelter[MAX_SHELTERNUM]; //ڵ
    BOOL m_bShelter;  //ڵťǷ񱻵

    NET_DVR_MOTION_V30  m_struMotion; //ƶ
    BOOL m_bMotion; //ƶⰴťǷ񱻵

    NET_DVR_HIDEALARM_V30   m_struHide; //ڵ
    BOOL m_bHide; //ڵİťǷ񱻵

    //ʾַ

    //set the value of each compress widget.ѹ
    int setEachCompWidget(LPNET_DVR_COMPRESSION_INFO_V30 pCompressInfo);
    //get the value of each compress widget.
    int getEachCompWidget(LPNET_DVR_COMPRESSION_INFO_V30 pCompressInfo);
};

#endif // CCHANNELPARAMS_H
